diff --git a/base/java-tools/src/com/netscape/cmstools/key/KeyFindCLI.java b/base/java-tools/src/com/netscape/cmstools/key/KeyFindCLI.java
index 014a9b60e3067cf32eb89793554accb8ca590166..9a91f37e2b4bf8f4a78670a1aa2cfc5aa0b10bde 100644
--- a/base/java-tools/src/com/netscape/cmstools/key/KeyFindCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/key/KeyFindCLI.java
@@ -34,15 +34,15 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class KeyFindCLI extends CLI {
 
-    public KeyCLI parent;
+    public KeyCLI keyCLI;
 
-    public KeyFindCLI(KeyCLI parent) {
-        super("find", "Find keys");
-        this.parent = parent;
+    public KeyFindCLI(KeyCLI keyCLI) {
+        super("find", "Find keys", keyCLI);
+        this.keyCLI = keyCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " [OPTIONS...]", options);
+        formatter.printHelp(getFullName() + " [OPTIONS...]", options);
     }
 
     public void execute(String[] args) {
@@ -83,7 +83,7 @@ public class KeyFindCLI extends CLI {
         s = cmd.getOptionValue("maxTime");
         Integer maxTime = s == null ? null : Integer.valueOf(s);
 
-        KeyDataInfos keys = parent.keyClient.findKeys(clientID, status, maxResults, maxTime);
+        KeyDataInfos keys = keyCLI.keyClient.findKeys(clientID, status, maxResults, maxTime);
 
         Collection<KeyDataInfo> entries = keys.getKeyInfos();
 
diff --git a/base/java-tools/src/com/netscape/cmstools/key/KeyRequestFindCLI.java b/base/java-tools/src/com/netscape/cmstools/key/KeyRequestFindCLI.java
index 83ce4231837f205375c2da5ebfce82876e811a70..14770efdb59db75c329e327fb5a5ce39fd14aac9 100644
--- a/base/java-tools/src/com/netscape/cmstools/key/KeyRequestFindCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/key/KeyRequestFindCLI.java
@@ -35,15 +35,15 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class KeyRequestFindCLI extends CLI {
 
-    public KeyCLI parent;
+    public KeyCLI keyCLI;
 
-    public KeyRequestFindCLI(KeyCLI parent) {
-        super("request-find", "Find key requests");
-        this.parent = parent;
+    public KeyRequestFindCLI(KeyCLI keyCLI) {
+        super("request-find", "Find key requests", keyCLI);
+        this.keyCLI = keyCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " [OPTIONS...]", options);
+        formatter.printHelp(getFullName() + " [OPTIONS...]", options);
     }
 
     public void execute(String[] args) {
@@ -95,7 +95,7 @@ public class KeyRequestFindCLI extends CLI {
         s = cmd.getOptionValue("maxTime");
         Integer maxTime = s == null ? null : Integer.valueOf(s);
 
-        KeyRequestInfos keys = parent.keyClient.findKeyRequests(
+        KeyRequestInfos keys = keyCLI.keyClient.findKeyRequests(
                 status, type, clientID, start, pageSize, maxResults, maxTime);
 
         Collection<KeyRequestInfo> entries = keys.getRequests();
diff --git a/base/java-tools/src/com/netscape/cmstools/profile/ProfileAddCLI.java b/base/java-tools/src/com/netscape/cmstools/profile/ProfileAddCLI.java
index 2c30fdbd7cb693d556600061abc712acdc2439ba..17f7998f9aa8a9ef12ed131bdc6c40f97a08fd8c 100644
--- a/base/java-tools/src/com/netscape/cmstools/profile/ProfileAddCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/profile/ProfileAddCLI.java
@@ -12,15 +12,16 @@ import com.netscape.cmstools.cli.CLI;
 import com.netscape.cmstools.cli.MainCLI;
 
 public class ProfileAddCLI extends CLI {
-    public ProfileCLI parent;
 
-    public ProfileAddCLI(ProfileCLI parent) {
-        super("add", "Add profiles");
-        this.parent = parent;
+    public ProfileCLI profileCLI;
+
+    public ProfileAddCLI(ProfileCLI profileCLI) {
+        super("add", "Add profiles", profileCLI);
+        this.profileCLI = profileCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <file>", options);
+        formatter.printHelp(getFullName() + " <file>", options);
     }
 
     public void execute(String[] args) {
@@ -50,7 +51,7 @@ public class ProfileAddCLI extends CLI {
 
         try {
             ProfileData data = ProfileCLI.readProfileFromFile(filename);
-            parent.client.createProfile(data);
+            profileCLI.profileClient.createProfile(data);
             MainCLI.printMessage("Added profile " + data.getId());
         } catch (FileNotFoundException | JAXBException  e) {
             System.err.println("Error: " + e.getMessage());
diff --git a/base/java-tools/src/com/netscape/cmstools/profile/ProfileCLI.java b/base/java-tools/src/com/netscape/cmstools/profile/ProfileCLI.java
index ba41a3da1c3fee1957dcd816e2a21d2a0eceafd4..59f63c7e9f2109a52978f6e11d8e6f534c576bdd 100644
--- a/base/java-tools/src/com/netscape/cmstools/profile/ProfileCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/profile/ProfileCLI.java
@@ -12,8 +12,6 @@ import javax.xml.bind.JAXBException;
 import javax.xml.bind.Marshaller;
 import javax.xml.bind.Unmarshaller;
 
-import org.apache.commons.lang.StringUtils;
-
 import com.netscape.certsrv.profile.ProfileAttribute;
 import com.netscape.certsrv.profile.ProfileClient;
 import com.netscape.certsrv.profile.ProfileData;
@@ -24,12 +22,11 @@ import com.netscape.cmstools.cli.CLI;
 import com.netscape.cmstools.cli.MainCLI;
 
 public class ProfileCLI extends CLI {
-    public MainCLI parent;
-    public ProfileClient client;
 
-    public ProfileCLI(MainCLI parent) {
-        super("profile", "Profile management commands");
-        this.parent = parent;
+    public ProfileClient profileClient;
+
+    public ProfileCLI(CLI parent) {
+        super("profile", "Profile management commands", parent);
 
         addModule(new ProfileFindCLI(this));
         addModule(new ProfileShowCLI(this));
@@ -40,30 +37,19 @@ public class ProfileCLI extends CLI {
         addModule(new ProfileDisableCLI(this));
     }
 
-    public void printHelp() {
-
-        System.out.println("Commands:");
-
-        int leftPadding = 1;
-        int rightPadding = 25;
-
-        for (CLI module : modules.values()) {
-            String label = name + "-" + module.getName();
-
-            int padding = rightPadding - leftPadding - label.length();
-            if (padding < 1)
-                padding = 1;
-
-            System.out.print(StringUtils.repeat(" ", leftPadding));
-            System.out.print(label);
-            System.out.print(StringUtils.repeat(" ", padding));
-            System.out.println(module.getDescription());
+    public String getFullName() {
+        if (parent instanceof MainCLI) {
+            // do not include MainCLI's name
+            return name;
+        } else {
+            return parent.getFullName() + "-" + name;
         }
     }
 
     public void execute(String[] args) throws Exception {
 
-        client = new ProfileClient(parent.client);
+        client = parent.getClient();
+        profileClient = new ProfileClient(client);
 
         if (args.length == 0) {
             printHelp();
diff --git a/base/java-tools/src/com/netscape/cmstools/profile/ProfileDisableCLI.java b/base/java-tools/src/com/netscape/cmstools/profile/ProfileDisableCLI.java
index 0279cf36a879accd885c6aa3834f9e89fe8e71c1..4fc640d75f4f9ecf7eac8422faba50530010209b 100644
--- a/base/java-tools/src/com/netscape/cmstools/profile/ProfileDisableCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/profile/ProfileDisableCLI.java
@@ -5,15 +5,15 @@ import com.netscape.cmstools.cli.MainCLI;
 
 public class ProfileDisableCLI extends CLI {
 
-    public ProfileCLI parent;
+    public ProfileCLI profileCLI;
 
-    public ProfileDisableCLI(ProfileCLI parent) {
-        super("disable", "Disable profiles");
-        this.parent = parent;
+    public ProfileDisableCLI(ProfileCLI profileCLI) {
+        super("disable", "Disable profiles", profileCLI);
+        this.profileCLI = profileCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <profile_id>", options);
+        formatter.printHelp(getFullName() + " <Profile ID>", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -25,7 +25,7 @@ public class ProfileDisableCLI extends CLI {
 
         String profileId = args[0];
 
-        parent.client.disableProfile(profileId);
+        profileCLI.profileClient.disableProfile(profileId);
 
         MainCLI.printMessage("Disabled profile \"" + profileId + "\"");
     }
diff --git a/base/java-tools/src/com/netscape/cmstools/profile/ProfileEnableCLI.java b/base/java-tools/src/com/netscape/cmstools/profile/ProfileEnableCLI.java
index 727e49b0ac429f38f3b5336e17214bdcb3027e9a..88c96c52b6de6ab389ef52a829c76c1c037555b0 100644
--- a/base/java-tools/src/com/netscape/cmstools/profile/ProfileEnableCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/profile/ProfileEnableCLI.java
@@ -5,15 +5,15 @@ import com.netscape.cmstools.cli.MainCLI;
 
 public class ProfileEnableCLI extends CLI {
 
-    public ProfileCLI parent;
+    public ProfileCLI profileCLI;
 
-    public ProfileEnableCLI(ProfileCLI parent) {
-        super("enable", "Enable profiles");
-        this.parent = parent;
+    public ProfileEnableCLI(ProfileCLI profileCLI) {
+        super("enable", "Enable profiles", profileCLI);
+        this.profileCLI = profileCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <profile_id>", options);
+        formatter.printHelp(getFullName() + " <Profile ID>", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -25,7 +25,7 @@ public class ProfileEnableCLI extends CLI {
 
         String profileId = args[0];
 
-        parent.client.enableProfile(profileId);
+        profileCLI.profileClient.enableProfile(profileId);
 
         MainCLI.printMessage("Enabled profile \"" + profileId + "\"");
     }
diff --git a/base/java-tools/src/com/netscape/cmstools/profile/ProfileFindCLI.java b/base/java-tools/src/com/netscape/cmstools/profile/ProfileFindCLI.java
index 9ced7c0b8174be186b0942b7a2b43183d65609b5..1370319f9e59e74080bef1c638290a10eb728f95 100644
--- a/base/java-tools/src/com/netscape/cmstools/profile/ProfileFindCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/profile/ProfileFindCLI.java
@@ -8,20 +8,20 @@ import com.netscape.cmstools.cli.MainCLI;
 
 public class ProfileFindCLI extends CLI {
 
-    public ProfileCLI parent;
+    public ProfileCLI profileCLI;
 
-    public ProfileFindCLI(ProfileCLI parent) {
-        super("find", "Find profiles");
-        this.parent = parent;
+    public ProfileFindCLI(ProfileCLI profileCLI) {
+        super("find", "Find profiles", profileCLI);
+        this.profileCLI = profileCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " [FILTER] [OPTIONS...]", options);
+        formatter.printHelp(getFullName() + " [FILTER] [OPTIONS...]", options);
     }
 
     public void execute(String[] args) throws Exception {
 
-        Collection<ProfileDataInfo> infos = parent.client.listProfiles().getProfileInfos();
+        Collection<ProfileDataInfo> infos = profileCLI.profileClient.listProfiles().getProfileInfos();
         boolean first = true;
 
         for (ProfileDataInfo info: infos) {
diff --git a/base/java-tools/src/com/netscape/cmstools/profile/ProfileModifyCLI.java b/base/java-tools/src/com/netscape/cmstools/profile/ProfileModifyCLI.java
index 5259a7fe7a92e2e5212a9855b7faf3e13b6824a2..e1c5436724c5df627947744999faf6523794e7b6 100644
--- a/base/java-tools/src/com/netscape/cmstools/profile/ProfileModifyCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/profile/ProfileModifyCLI.java
@@ -13,15 +13,15 @@ import com.netscape.cmstools.cli.MainCLI;
 
 public class ProfileModifyCLI extends CLI {
 
-    public ProfileCLI parent;
+    public ProfileCLI profileCLI;
 
-    public ProfileModifyCLI(ProfileCLI parent) {
-        super("mod", "Modify profiles");
-        this.parent = parent;
+    public ProfileModifyCLI(ProfileCLI profileCLI) {
+        super("mod", "Modify profiles", profileCLI);
+        this.profileCLI = profileCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <file>", options);
+        formatter.printHelp(getFullName() + " <file>", options);
     }
 
     public void execute(String[] args) {
@@ -51,7 +51,7 @@ public class ProfileModifyCLI extends CLI {
 
         try {
             ProfileData data = ProfileCLI.readProfileFromFile(filename);
-            parent.client.modifyProfile(data);
+            profileCLI.profileClient.modifyProfile(data);
             MainCLI.printMessage("Modified profile " + data.getId());
         } catch (FileNotFoundException | JAXBException  e) {
             System.err.println("Error: " + e.getMessage());
diff --git a/base/java-tools/src/com/netscape/cmstools/profile/ProfileRemoveCLI.java b/base/java-tools/src/com/netscape/cmstools/profile/ProfileRemoveCLI.java
index c2e3eae53f4879869fd474af99fbd2221a60ac59..92c99ede8544d953ec95af733237ef0e0434ff05 100644
--- a/base/java-tools/src/com/netscape/cmstools/profile/ProfileRemoveCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/profile/ProfileRemoveCLI.java
@@ -5,15 +5,15 @@ import com.netscape.cmstools.cli.MainCLI;
 
 public class ProfileRemoveCLI extends CLI {
 
-    public ProfileCLI parent;
+    public ProfileCLI profileCLI;
 
-    public ProfileRemoveCLI(ProfileCLI parent) {
-        super("del", "Remove profiles");
-        this.parent = parent;
+    public ProfileRemoveCLI(ProfileCLI profileCLI) {
+        super("del", "Remove profiles", profileCLI);
+        this.profileCLI = profileCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <profile_id>", options);
+        formatter.printHelp(getFullName() + " <Profile ID>", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -25,7 +25,7 @@ public class ProfileRemoveCLI extends CLI {
 
         String profileId = args[0];
 
-        parent.client.deleteProfile(profileId);
+        profileCLI.profileClient.deleteProfile(profileId);
 
         MainCLI.printMessage("Deleted profile \"" + profileId + "\"");
     }
diff --git a/base/java-tools/src/com/netscape/cmstools/profile/ProfileShowCLI.java b/base/java-tools/src/com/netscape/cmstools/profile/ProfileShowCLI.java
index c3f8675f2e11a870d5d19020a2432a39bc1fb033..6b09d7f9d67ca4b02500e25309dd41609b2d232e 100644
--- a/base/java-tools/src/com/netscape/cmstools/profile/ProfileShowCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/profile/ProfileShowCLI.java
@@ -10,15 +10,15 @@ import com.netscape.cmstools.cli.MainCLI;
 
 public class ProfileShowCLI extends CLI {
 
-    public ProfileCLI parent;
+    public ProfileCLI profileCLI;
 
-    public ProfileShowCLI(ProfileCLI parent) {
-        super("show", "Show profiles");
-        this.parent = parent;
+    public ProfileShowCLI(ProfileCLI profileCLI) {
+        super("show", "Show profiles", profileCLI);
+        this.profileCLI = profileCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <profile_id>", options);
+        formatter.printHelp(getFullName() + " <Profile ID>", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -56,14 +56,14 @@ public class ProfileShowCLI extends CLI {
             }
         }
 
-        ProfileData profileData = parent.client.retrieveProfile(profileId);
+        ProfileData profileData = profileCLI.profileClient.retrieveProfile(profileId);
 
         MainCLI.printMessage("Profile \"" + profileId + "\"");
 
         if (filename != null) {
             ProfileCLI.saveProfileToFile(filename, profileData);
         } else {
-            ProfileCLI.printProfile(profileData, parent.parent.config.getServerURI());
+            ProfileCLI.printProfile(profileData, profileCLI.getClient().getConfig().getServerURI());
         }
     }
 
diff --git a/base/java-tools/src/com/netscape/cmstools/system/KRAConnectorAddCLI.java b/base/java-tools/src/com/netscape/cmstools/system/KRAConnectorAddCLI.java
index cc163341b0448ea13b8e9ab8d49ba9613fd5f30a..cc08d7513f56e4bec539d9367cb230ec4651c916 100644
--- a/base/java-tools/src/com/netscape/cmstools/system/KRAConnectorAddCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/system/KRAConnectorAddCLI.java
@@ -33,15 +33,16 @@ import com.netscape.cmstools.cli.MainCLI;
  * @author Ade Lee
  */
 public class KRAConnectorAddCLI extends CLI {
-    public KRAConnectorCLI parent;
 
-    public KRAConnectorAddCLI(KRAConnectorCLI parent) {
-        super("add", "Add KRA Connector");
-        this.parent = parent;
+    public KRAConnectorCLI kraConnectorCLI;
+
+    public KRAConnectorAddCLI(KRAConnectorCLI kraConnectorCLI) {
+        super("add", "Add KRA Connector", kraConnectorCLI);
+        this.kraConnectorCLI = kraConnectorCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <File Name>", options);
+        formatter.printHelp(getFullName() + " <File Name>", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -70,7 +71,7 @@ public class KRAConnectorAddCLI extends CLI {
         Unmarshaller unmarshaller = context.createUnmarshaller();
         KRAConnectorInfo info = (KRAConnectorInfo) unmarshaller.unmarshal(fis);
 
-        parent.client.addConnector(info);
+        kraConnectorCLI.kraConnectorClient.addConnector(info);
 
         MainCLI.printMessage("Added KRA Connector");
     }
diff --git a/base/java-tools/src/com/netscape/cmstools/system/KRAConnectorCLI.java b/base/java-tools/src/com/netscape/cmstools/system/KRAConnectorCLI.java
index 03db762d41f17ee6fc4f1ab21d209e920a44c4de..a24a4fd00a304ded72061d53e3f9b3ab1f7c95cc 100644
--- a/base/java-tools/src/com/netscape/cmstools/system/KRAConnectorCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/system/KRAConnectorCLI.java
@@ -19,8 +19,6 @@ package com.netscape.cmstools.system;
 
 import java.util.Arrays;
 
-import org.apache.commons.lang.StringUtils;
-
 import com.netscape.certsrv.system.KRAConnectorClient;
 import com.netscape.cmstools.cli.CLI;
 import com.netscape.cmstools.cli.MainCLI;
@@ -30,39 +28,28 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class KRAConnectorCLI extends CLI {
 
-    public MainCLI parent;
-    public KRAConnectorClient client;
+    public KRAConnectorClient kraConnectorClient;
+
+    public KRAConnectorCLI(CLI parent) {
+        super("kraconnector", "KRA Connector management commands", parent);
 
-    public KRAConnectorCLI(MainCLI parent) {
-        super("kraconnector", "KRA Connector management commands");
-        this.parent = parent;
         addModule(new KRAConnectorAddCLI(this));
         addModule(new KRAConnectorRemoveCLI(this));
     }
 
-    public void printHelp() {
-
-        System.out.println("Commands:");
-
-        int leftPadding = 1;
-        int rightPadding = 25;
-
-        for (CLI module : modules.values()) {
-            String label = name+"-"+module.getName();
-
-            int padding = rightPadding - leftPadding - label.length();
-            if (padding < 1) padding = 1;
-
-            System.out.print(StringUtils.repeat(" ", leftPadding));
-            System.out.print(label);
-            System.out.print(StringUtils.repeat(" ", padding));
-            System.out.println(module.getDescription());
+    public String getFullName() {
+        if (parent instanceof MainCLI) {
+            // do not include MainCLI's name
+            return name;
+        } else {
+            return parent.getFullName() + "-" + name;
         }
     }
 
     public void execute(String[] args) throws Exception {
 
-        client = new KRAConnectorClient(parent.client);
+        client = parent.getClient();
+        kraConnectorClient = new KRAConnectorClient(client);
 
         if (args.length == 0) {
             printHelp();
diff --git a/base/java-tools/src/com/netscape/cmstools/system/KRAConnectorRemoveCLI.java b/base/java-tools/src/com/netscape/cmstools/system/KRAConnectorRemoveCLI.java
index d69e08ed4ee6a0f5c0e680d0033359d95c1590d0..550b661d22df1b93d29c2ac0438ddbd8c15f8538 100644
--- a/base/java-tools/src/com/netscape/cmstools/system/KRAConnectorRemoveCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/system/KRAConnectorRemoveCLI.java
@@ -24,15 +24,16 @@ import com.netscape.cmstools.cli.MainCLI;
  * @author Ade Lee
  */
 public class KRAConnectorRemoveCLI extends CLI {
-    public KRAConnectorCLI parent;
 
-    public KRAConnectorRemoveCLI(KRAConnectorCLI parent) {
-        super("del", "Remove KRA connector from CA");
-        this.parent = parent;
+    public KRAConnectorCLI kraConnectorCLI;
+
+    public KRAConnectorRemoveCLI(KRAConnectorCLI kraConnectorCLI) {
+        super("del", "Remove KRA connector from CA", kraConnectorCLI);
+        this.kraConnectorCLI = kraConnectorCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <KRA Host> <KRA Port>", options);
+        formatter.printHelp(getFullName() + " <KRA Host> <KRA Port>", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -45,7 +46,7 @@ public class KRAConnectorRemoveCLI extends CLI {
         String kraHost = args[0];
         String kraPort = args[1];
 
-        parent.client.removeConnector(kraHost, kraPort);
+        kraConnectorCLI.kraConnectorClient.removeConnector(kraHost, kraPort);
 
         MainCLI.printMessage("Removed KRA connector \""+kraHost + ":" + kraPort +"\"");
     }
diff --git a/base/java-tools/src/com/netscape/cmstools/system/SecurityDomainCLI.java b/base/java-tools/src/com/netscape/cmstools/system/SecurityDomainCLI.java
index fc23a5257a389f256060d7a610c10c2b9c98ac53..3ea3e78dee65d91b287ec418159d4e0e8f37f754 100644
--- a/base/java-tools/src/com/netscape/cmstools/system/SecurityDomainCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/system/SecurityDomainCLI.java
@@ -20,8 +20,6 @@ package com.netscape.cmstools.system;
 
 import java.util.Arrays;
 
-import org.apache.commons.lang.StringUtils;
-
 import com.netscape.certsrv.system.DomainInfo;
 import com.netscape.certsrv.system.SecurityDomainClient;
 import com.netscape.certsrv.system.SecurityDomainHost;
@@ -34,41 +32,28 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class SecurityDomainCLI extends CLI {
 
-    public MainCLI parent;
-    public SecurityDomainClient client;
+    public SecurityDomainClient securityDomainClient;
 
-    public SecurityDomainCLI(MainCLI parent) {
-        super("securitydomain", "Security domain commands");
-        this.parent = parent;
+    public SecurityDomainCLI(CLI parent) {
+        super("securitydomain", "Security domain commands", parent);
 
         addModule(new SecurityDomainGetInstallTokenCLI(this));
         addModule(new SecurityDomainShowCLI(this));
     }
 
-    public void printHelp() {
-
-        System.out.println("Commands:");
-
-        int leftPadding = 1;
-        int rightPadding = 25;
-
-        for (CLI module : modules.values()) {
-            String label = name + "-" + module.getName();
-
-            int padding = rightPadding - leftPadding - label.length();
-            if (padding < 1)
-                padding = 1;
-
-            System.out.print(StringUtils.repeat(" ", leftPadding));
-            System.out.print(label);
-            System.out.print(StringUtils.repeat(" ", padding));
-            System.out.println(module.getDescription());
+    public String getFullName() {
+        if (parent instanceof MainCLI) {
+            // do not include MainCLI's name
+            return name;
+        } else {
+            return parent.getFullName() + "-" + name;
         }
     }
 
     public void execute(String[] args) throws Exception {
 
-        client = new SecurityDomainClient(parent.client);
+        client = parent.getClient();
+        securityDomainClient = new SecurityDomainClient(client);
 
         if (args.length == 0) {
             printHelp();
diff --git a/base/java-tools/src/com/netscape/cmstools/system/SecurityDomainGetInstallTokenCLI.java b/base/java-tools/src/com/netscape/cmstools/system/SecurityDomainGetInstallTokenCLI.java
index 2d21f733d79c6fe0ace74f95c9257c8d82873807..f05535c94afdceb49ff235b3eb947d1db2efaa72 100644
--- a/base/java-tools/src/com/netscape/cmstools/system/SecurityDomainGetInstallTokenCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/system/SecurityDomainGetInstallTokenCLI.java
@@ -32,15 +32,15 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class SecurityDomainGetInstallTokenCLI extends CLI {
 
-    public SecurityDomainCLI parent;
+    public SecurityDomainCLI securityDomainCLI;
 
-    public SecurityDomainGetInstallTokenCLI(SecurityDomainCLI parent) {
-        super("get-install-token", "Get install token");
-        this.parent = parent;
+    public SecurityDomainGetInstallTokenCLI(SecurityDomainCLI securityDomainCLI) {
+        super("get-install-token", "Get install token", securityDomainCLI);
+        this.securityDomainCLI = securityDomainCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " [OPTIONS...]", options);
+        formatter.printHelp(getFullName() + " [OPTIONS...]", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -79,7 +79,7 @@ public class SecurityDomainGetInstallTokenCLI extends CLI {
 
         String subsystem = cmd.getOptionValue("subsystem");
 
-        InstallToken token = parent.client.getInstallToken(hostname, subsystem);
+        InstallToken token = securityDomainCLI.securityDomainClient.getInstallToken(hostname, subsystem);
 
         MainCLI.printMessage("Install token: \"" + token.getToken() + "\"");
     }
diff --git a/base/java-tools/src/com/netscape/cmstools/system/SecurityDomainShowCLI.java b/base/java-tools/src/com/netscape/cmstools/system/SecurityDomainShowCLI.java
index 14664dbcf94181ca46c6954cdb51cf2c426c04f5..c0efa9f83ab406fa77786e9c392e9184c3224405 100644
--- a/base/java-tools/src/com/netscape/cmstools/system/SecurityDomainShowCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/system/SecurityDomainShowCLI.java
@@ -28,15 +28,15 @@ import com.netscape.cmstools.cli.CLI;
  */
 public class SecurityDomainShowCLI extends CLI {
 
-    public SecurityDomainCLI parent;
+    public SecurityDomainCLI securityDomainCLI;
 
-    public SecurityDomainShowCLI(SecurityDomainCLI parent) {
-        super("show", "Show domain info");
-        this.parent = parent;
+    public SecurityDomainShowCLI(SecurityDomainCLI securityDomainCLI) {
+        super("show", "Show domain info", securityDomainCLI);
+        this.securityDomainCLI = securityDomainCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name, options);
+        formatter.printHelp(getFullName(), options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -59,7 +59,7 @@ public class SecurityDomainShowCLI extends CLI {
             System.exit(1);
         }
 
-        DomainInfo domain = parent.client.getDomainInfo();
+        DomainInfo domain = securityDomainCLI.securityDomainClient.getDomainInfo();
 
         SecurityDomainCLI.printSecurityDomain(domain);
     }
diff --git a/base/java-tools/src/com/netscape/cmstools/token/TokenCLI.java b/base/java-tools/src/com/netscape/cmstools/token/TokenCLI.java
index 539ce7bae01dc8cd9a8a91583a09d348e1fba8fb..4584a5ef7d99d201780319566498569d41a77c0f 100644
--- a/base/java-tools/src/com/netscape/cmstools/token/TokenCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/token/TokenCLI.java
@@ -18,25 +18,24 @@
 
 package com.netscape.cmstools.token;
 
-import org.apache.commons.lang.StringUtils;
+import java.util.Arrays;
+
 import org.jboss.resteasy.plugins.providers.atom.Link;
 
 import com.netscape.certsrv.token.TokenClient;
 import com.netscape.certsrv.token.TokenData;
 import com.netscape.cmstools.cli.CLI;
-import com.netscape.cmstools.cli.TPSCLI;
+import com.netscape.cmstools.cli.SubsystemCLI;
 
 /**
  * @author Endi S. Dewata
  */
 public class TokenCLI extends CLI {
 
-    public TPSCLI tpsCLI;
     public TokenClient tokenClient;
 
-    public TokenCLI(TPSCLI tpsCLI) {
-        super("token", "Token management commands", tpsCLI);
-        this.tpsCLI = tpsCLI;
+    public TokenCLI(SubsystemCLI subsystemCLI) {
+        super("token", "Token management commands", subsystemCLI);
 
         addModule(new TokenAddCLI(this));
         addModule(new TokenFindCLI(this));
@@ -45,34 +44,10 @@ public class TokenCLI extends CLI {
         addModule(new TokenShowCLI(this));
     }
 
-    public String getFullName() {
-        return parent.getName() + "-" + name;
-    }
-
-    public void printHelp() {
-
-        System.out.println("Commands:");
-
-        int leftPadding = 1;
-        int rightPadding = 25;
-
-        for (CLI module : modules.values()) {
-            String label = getFullName() + "-" + module.getName();
-
-            int padding = rightPadding - leftPadding - label.length();
-            if (padding < 1)
-                padding = 1;
-
-            System.out.print(StringUtils.repeat(" ", leftPadding));
-            System.out.print(label);
-            System.out.print(StringUtils.repeat(" ", padding));
-            System.out.println(module.getDescription());
-        }
-    }
-
     public void execute(String[] args) throws Exception {
 
-        tokenClient = new TokenClient(tpsCLI.mainCLI.client);
+        client = parent.getClient();
+        tokenClient = (TokenClient)parent.getClient("token");
 
         if (args.length == 0) {
             printHelp();
@@ -80,42 +55,22 @@ public class TokenCLI extends CLI {
         }
 
         String command = args[0];
-        String moduleName;
-        String moduleCommand;
+        String[] commandArgs = Arrays.copyOfRange(args, 1, args.length);
 
-        // If a command contains a '-' sign it will be
-        // split into module name and module command.
-        // Otherwise it's a single command.
-        int i = command.indexOf('-');
-        if (i >= 0) { // <module name>-<module command>
-            moduleName = command.substring(0, i);
-            moduleCommand = command.substring(i+1);
-
-        } else { // <command>
-            moduleName = command;
-            moduleCommand = null;
-        }
-
-        // get command module
-        if (verbose) System.out.println("Module: " + moduleName);
-        CLI module = getModule(moduleName);
-        if (module == null) {
-            throw new Error("Invalid module \"" + moduleName + "\".");
+        if (command == null) {
+            printHelp();
+            System.exit(1);
         }
 
-        // prepare module arguments
-        String[] moduleArgs;
-        if (moduleCommand != null) {
-            moduleArgs = new String[args.length];
-            moduleArgs[0] = moduleCommand;
-            System.arraycopy(args, 1, moduleArgs, 1, args.length-1);
+        CLI module = getModule(command);
+        if (module != null) {
+            module.execute(commandArgs);
 
         } else {
-            moduleArgs = new String[args.length-1];
-            System.arraycopy(args, 1, moduleArgs, 0, args.length-1);
+            System.err.println("Error: Invalid command \"" + command + "\"");
+            printHelp();
+            System.exit(1);
         }
-
-        module.execute(moduleArgs);
     }
 
     public static void printToken(TokenData token) {
